CVE-2019-14287复现

  1. 前言
  2. 环境
  3. 漏洞概述
  4. 实验过程

前言

今天在公众号见到消息说是,那就复现一哈子吧
KP2TZn.png

环境

VM:Kali

漏洞概述

这个漏洞的 CVE 编号是CVE-2019-14287,是由苹果信息安全部门的研究员 Joe Vennix 发现并分析的。与其说让人恐慌,不如说让人兴趣盎然:它要求系统具有非标准配置。换句话说,在默认情况下,Linux 计算机并不易受攻击。然而,如果你的配置是这样的:让用户以 root 权限以外的其他用户权限运行命令,那么可能就需要注意了:因为用户可以通过命令行上的 –u#-1 绕过这个非 root限制。如果将 sudo配置为允许用户通过Runas 规范中的 ALL 关键字以任意用户身份运行命令,则可以通过指定用户 ID为-1 或4294967295 以 root 用户身份运行命令。只要Runas 规范中最先列出 ALL 关键字,即使Runas 规范明确禁止 root访问权限,那么具有足够的 sudo 权限的而用户即可以 root 身份运行命令。以这种方式运行的命令的日志条目会把目标用户列为 4294967295而非 root。另外,将不会为该命令运行 PAM 会话模块。具体而言:利用该漏洞要求用户具有 sudo 权限,从而以任意用户 ID 运行命令。一般而言,这意味着用户的 sudoers 条目在 Runas 规范中具有特殊值 ALL。Sudo 支持在 sudoers 策略允许的情况下,以用户指定的名称或用户 ID 运行命令。例如,如下 sudoers 条目允许 id 命令以任意用户身份运行,因为它包含 Runas 规范中的关键字 ALL

漏洞影响范围

1.8.28之前的所有 Sudo 版本均受影响

修复方案

Sudo 1.8.28 版本已修复该漏洞。强烈建议 Linux用户将 sudo包手动更新至最新版本

实验过程

在/etc/sudoers 文件中写入一行

myhost alice = (ALL) /usr/bin/id

KPRFJK.png

执行以下command即可以root权限运行id命令

 sudo -u#4294967295 id

KPRkRO.png

更直观的感受一下,把命令id改为cat,然后以demo用户读取/etc/shadow
KPRudI.png

KPRaoq.png

这究竟是为啥子会有这种操作出现呢
KPRAzD.png

KPRZsH.png

参考链接:Linux Sudo被曝漏洞,可导致用户以root权限运行命令 - FreeBuf互联网安全新媒体平台


转载请注明来源,欢迎对文章中的引用来源进行考证,欢迎指出任何有错误或不够清晰的表达。

文章标题:CVE-2019-14287复现

本文作者:九世

发布时间:2019-10-15, 23:18:33

最后更新:2019-10-15, 23:34:02

原始链接:http://422926799.github.io/posts/13cae37e.html

版权声明: "署名-非商用-相同方式共享 4.0" 转载请保留原文链接及作者。

目录